#!/usr/bin/env python
#
# Author: Jason Batchelor
# Description: Extract and process file contained within a GZIP archive 
# Date: 11/16/2015
'''
   Copyright 2015 Emerson Electric Co.

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
'''

import sys
import gzip
from StringIO import StringIO

def EXTRACT_GZIP(s, buff):

   # Only one file within a GZIP, you'll never have multiple ones
   # For that, you'll likely see something like GZ+TAR
   gzf = gzip.GzipFile(fileobj=StringIO(buff), mode='rb')

   EXTRACT_GZIP = {'Object': {'Buffer': gzf.read()}}

   return EXTRACT_GZIP

if __name__ == '__main__':
   print EXTRACT_GZIP(None, sys.stdin.read())
